///home/berryj/link/bin/genMethods "-g" "-t" "Edge*" "-h" "SortedList" "-r" "List<Edge*>" "-I" "LINK/basic/List.h" "-I" "LINK/graph/Edge.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/List.h>

#include <LINK/graph/Edge.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Edge* _Edge_;
typedef SortedList<Edge* > _SortedList_Edge__;
static SortedList<Edge* > s__SortedList_Edge__;

#define _SortedList_Edge__DATA(x) ((SortedList<Edge* >*) (EXTDATA(x)))
#define _SortedList_Edge__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<Edge* > >::type))
#define _SortedList_Edge__ISNT_DATA(x) (!_SortedList_Edge__IS_DATA(x))

#define _SortedList_Edge__CXX_DATA(x) (*(SortedList<Edge* >*) (EXTDATA(VAL(x))))
#define _SortedList_Edge__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<Edge* > >::type))
#define _SortedList_Edge__CXX_ISNT_DATA(x) (!_SortedList_Edge__CXX_IS_DATA(x))


PRIMITIVE STk_init__SortedList_Edge__()
{
	Wrapper<_SortedList_Edge__>::type = STk_new_CXXwrapper_id(
			Wrapper<_SortedList_Edge__>::name, 
			Wrapper<List<Edge*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Edge_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Edge_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Edge_>::freeTypedList);
	Tcl_InitHashTable(&Register<_SortedList_Edge__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_SortedList_Edge__Methods(void);

PRIMITIVE STk_init_methods__SortedList_Edge__()
{
	genExtra_SortedList_Edge__Methods();
	return UNDEFINED;
}
